# Release Guidelines for the CaosDB Python Client Library

This document specifies release guidelines in addition to the general release
guidelines of the CaosDB Project
([RELEASE_GUIDELINES.md](https://gitlab.com/caosdb/caosdb/blob/dev/RELEASE_GUIDELINES.md))

## General Prerequisites

* All tests are passing.
* CHANGELOG.md is up-to-date.
* DEPENDENCIES.md is up-to-date.

## Steps

1. Create a release branch from the dev branch. This prevents further changes
   to the code base and a never ending release process. Naming: `release-<VERSION>`

2. Update CHANGELOG.md:
   1. Rename the *Unreleased* section to the new version.
   2. Remove empty subsections.

3. Check all general prerequisites.

4. Check version numbers and dates:
   1. In `doc/conf.py`.
   2. In `DESCRIPTION`.

5. Merge the release branch into the main branch.

6. Tag the latest commit of the main branch with `v<VERSION>`.

7. Delete the release branch.

8. Merge the main branch back into the dev branch.

9. After the merge of main to dev, start a new development version by increasing at least the
   `MICRO` version.
   1. Re-add an *Unreleased* section to the CHANGELOG.md, with all subsections.
   2. Increase version number in `doc/conf.py`

